<template>
  <div>
    <div class="row sub-header">
      <div class="col-xs-8 flex">
        <div class="route-icon">
          <i
            style="font-size:28px; color:#0242AD"
            class="icon tractor-semi-trailer-refrizhirator-tent-b"
          ></i>
        </div>
        <div class="route-info">
          <div class="__way">{{ data.departureLocation.title || 'Не указано' }} → {{ data.arrivalLocation.title || 'Не указано' }}</div>
          <div class="__item" v-if="data.service">
            {{ data.service.resourceSpeciesTitle }}
            {{ data.service.resourceSubtypeTitle }}
            {{ data.service.resourcePatternParameter }}
          </div>
        </div>
      </div>
      <div
        v-if="data.base_price_reliability !== null"
        :class="['reliability', data.is_good_base_price_reliability ? 'reliability-high' : 'reliability-low']"
      >
        Достоверность БЦ
        <span class="reliability-value">{{data.base_price_reliability}}%</span>
      </div>
    </div>

    <div class="row">
      <ve-histogram
        :extend="chartExtend"
        :data="chartData"
        :loading="isBasePriceChartLoading && isAveragedBasePriceChartLoading"
        height="250px"
        width="100%"
      ></ve-histogram>
    </div>

    <div class="row">
      <span class="price-tip">Все цены указаны без НДС</span>
    </div>

    <div class="row">
      <div class="col-xs-4">
        <ob-input
          label="Базовая цена"
          type="money:2"
          subTitle="₽"
          :value="basePriceStage"
          disabled
        />
      </div>
      <div class="col-xs-4">
        <ob-input label="Цена за км" subTitle="₽/км" type="money:2" :value="basePriceKm" disabled />
      </div>
      <div class="col-xs-4">
        <ob-input label="Расстояние" subTitle="км" type="text" :value="distance" disabled />
      </div>
    </div>

    <div class="row base-price-calculate">
      <h3 class="modal-section-title">Расчет базовой цены (с учетом округления)</h3>

      <formula-view v-if="!!data.base_price" :items="basePriceFormulaData" />
    </div>

    <!-- <BalanceBetweenRow /> -->

    <div class="row">
      <ob-checkbox
        label="Назначить фиксированное значение БЦ вручную"
        :value="fixedPriceAvailability"
        @change="setFixedPriceAvailability($event)"
      />
      <slot v-if="fixedPriceAvailability">
        <div class="row" style="width: 100%;">
          <div class="col-xs-4">
            <ob-input
              type="money:2"
              label="Фиксированный тариф"
              subTitle="₽"
              :value="fixedPriceStage"
              @input="handleFixedPrice"
            />
          </div>
          <div class="col-xs-4">
            <ob-input
              type="money:2"
              label="Цена за км"
              subTitle="₽/км"
              :value="initialFixedPrice"
              ref="fixedPrice"
              disabled
            />
          </div>
          <div class="col-xs-4">
            <ob-input
              type="text"
              label="Расстояние"
              subTitle="км"
              :value="fixedPriceDistance"
              @input="handleFixedPriceDistance"
            />
          </div>
        </div>
      </slot>
    </div>

    <ob-modal
      ref="viewHistory"
      title="История изменения БЦ"
      size="medium"
      custom-class="modal-medium"
      :is-read-only="true"
      :is-show-controls="true"
    >
      <history-modal />
    </ob-modal>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

import ObInput from 'common-components/src/obComponents/obInput';
import obCheckbox from 'common-components/src/obComponents/obCheckbox';
import ObModal from 'common-components/src/obComponents/obModal';

import FormulaView from '../../../DynamicFormula';
import HistoryModal from '../HistoryModal';
import getBasePriceFormula from '../constants/baseFormula';
import { formatKopeykiToRubli } from '@/pages/basePricesPage/utils';

export default {
  name: 'BasePriceModalContent',
  components: {
    ObInput,
    obCheckbox,
    FormulaView,
    HistoryModal,
    ObModal,
  },
  props: {
    data: {
      type: Object,
      default: () => {},
    },
    distance: {
      type: Number,
      default: null,
    },
    fixedPriceStage: {
      type: Number,
      default: null,
    },
    fixedPrice: {
      type: Number,
      default: null,
    },
    fixedPriceDistance: {
      type: Number,
      default: null,
    },
    fixedPriceAvailability: {
      type: Boolean,
      default: false,
    },
    isSubmitDisabled: {
      type: Boolean,
      default: false
    },
  },
  data() {
    this.chartExtend = {
      yAxis: {
        axisLabel: {
          formatter: val => `${formatKopeykiToRubli(val, 1)} ₽`,
        },
      },
    };

    return {
      extrapolationDistance: 0,
      initialFixedPrice: 0,
      chartObj: {},
      chartData: {
        columns: ['date', 'Базовая цена', 'Среднесуточная цена'],
        rows: [],
      },
      basePriceFormulaData: [],
    };
  },
  computed: {
    ...mapGetters({
      basePriceFormula: 'base_prices/basePriceFormula',
      basePriceChart: 'base_prices/basePriceChart',
      isBasePriceChartLoading: 'base_prices/isBasePriceChartLoading',
      averagedBasePriceChart: 'base_prices/averagedBasePriceChart',
      isAveragedBasePriceChartLoading:
        'base_prices/isAveragedBasePriceChartLoading',
    }),
    // dropdownMenu() {
    //   return [
    //     {
    //       title: 'Просмотреть историю изменений БЦ',
    //       method: () => this.$refs.viewHistory.open()
    //     }
    //   ]
    // },
    basePrice() {
      return this.data.base_price || { price_stage: 0, price_km: 0 };
    },
    basePriceStage() {
      return this.basePrice.price_stage;
    },
    basePriceKm() {
      return this.basePrice.price_km;
    },
    fixedTotal() {
      if (this.fixedPriceDistance === null || this.fixedPrice === null) {
        return '';
      }
      const fixedTotal = this.fixedPriceDistance * this.fixedPrice;
      return fixedTotal;
    },
  },
  watch: {
    basePriceChart: function(val) {
      if (val && val.length) {
        val.forEach(row => {
          this.chartObj[row.date] = {
            ...(this.chartObj[row.date] ? this.chartObj[row.date] : {}),
            'Базовая цена': row.price_value,
            date: row.date,
          };
        });

        this.chartData.rows = Object.values(this.chartObj);
      }
    },
    averagedBasePriceChart: function(val) {
      if (val && val.length) {
        val.forEach(row => {
          this.chartObj[row.date] = {
            ...(this.chartObj[row.date] ? this.chartObj[row.date] : {}),
            'Среднесуточная цена': row.price_value,
            date: row.date,
          };
        });

        this.chartData.rows = Object.values(this.chartObj);
      }
    },
    basePriceFormula: function(val) {
      this.basePriceFormulaData = getBasePriceFormula(val);
    },
  },
  created() {
    this.initialFixedPrice = this.fixedPrice;
  },
  mounted() {
    const { base_price, uuid } = this.data;

    if (base_price && base_price.uuid) {
      this.getBasePriceFormula(base_price.uuid);
    }

    if (uuid) {
      this.getBasePriceChart(uuid);
      this.getAveragedBasePriceChart(uuid);
    }
  },
  methods: {
    ...mapActions({
      getBasePriceFormula: 'base_prices/getBasePriceFormula',
      getBasePriceChart: 'base_prices/getBasePriceChart',
      getAveragedBasePriceChart: 'base_prices/getAveragedBasePriceChart',
    }),
    handleFixedPrice(value) {
      this.$emit('fieldChanged', 'price_stage', +value);
    },
    handleFixedPriceDistance(value) {
      this.$emit('fieldChanged', 'fixedPriceDistance', +value);
    },

    setFixedPriceAvailability(value) {
      this.$emit('fieldChanged', 'fixedPriceAvailability', value);
    },
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;

@import '~common-components/src/static/css/mixins';

::v-deep {
  .modal-section-title {
    @include font-mixin(16px, 20px, 700, $cobalt-black, 0.4px);
    margin: 10px 0;
  }
}

.sub-header {
  display: flex;
  align-items: baseline;
  justify-content: space-between;

  .reliability {
    font-size: 12px;
    text-transform: uppercase;
    font-family: 'Roboto', sans-serif;

    &-high {
      color: #0fb785;
    }
    &-low {
      color: #e62d3b;
    }

    & .reliability-value {
      margin-left: 5px;
      font-size: 20px;
    }
  }
}

.flex {
  display: flex;
  align-items: center;
  .route-icon {
    margin-right: 13px;
  }
  .route-info {
    @include font-mixin(12px, 14px, 400, $cobalt-black, 0.4px);
    text-transform: uppercase;
  }
}

.price-tip {
  display: block;
  @include font-mixin(15px, 15px, 400, $gray-slate, 0.4px);
}

.base-price-calculate {
  display: flex;
  flex-direction: column;
  justify-content: center;
}
.calculateBtn{
  width: fit-content;
  margin-left: 0;
}
</style>
